Subject: Re: Pushing to a non-bare repository

From: Simon 'corecode' Schubert <[email-masked]>
Date: Sat, 03 Feb 2007 10:46:05 +0100

Junio C Hamano wrote:
>> This keeps coming up as I introduce people to git. In previous
>> discussions, the conclusion often seems to be that users don't really
>> know what they want the semantics to be.
> 
> I do not think that was the conclusion.  My suggestion to you
> would be to stop thinking as if push is a converse of pull
> (because it is not; push is a counterpart of fetch), and leave
> push as is.

However, your suggestion does not help people who don't know better.  Pushing into the HEAD branch of another repo breaks stuff there.  Badly.  This should be prevented, really.

I don't say "Push needs to behave like a fast forward pull", because that's wrong.  You can't just change the workdir, possibly due to permissions problems.  But push has to abort if you try to forward HEAD on the remote, except if it is bare, of course.

cheers
  simon

-- 
Serve - BSD     +++  RENT this banner advert  +++    ASCII Ribbon   /"\
Work - Mac      +++  space for low €€€ NOW!1  +++      Campaign     \ /
Party Enjoy Relax   |   http://dragonflybsd.org      Against  HTML   \
Dude 2c 2 the max   !   http://golden-apple.biz       Mail + News   / \